package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.MsgTemplate;

/**
 * 实体[WFAppSetting] 数据对象
 */
@TableName(value = "T_SRFWFAPPSETTING",resultMap = "WFAppSettingResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class WFAppSetting extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private MsgTemplate remindmsgtempl;
    private String applicationid;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String memo;
    @TableField(value= "remindmsgtempid")
    private String remindmsgtemplid;
    private String remindmsgtemplname;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    @TableId(value= "wfappsettingid",type=IdType.UUID)//指定主键生成策略
    private String wfappsettingid;
    private String wfappsettingname;
    /**
     *  设置属性值[APPLICATIONID]
     *  @param applicationid
     */
    public void setApplicationid(String applicationid){
        if(StringUtils.isEmpty(applicationid))
            applicationid=null;
        this.applicationid = applicationid;
        this.set("applicationiddirtyflag",true);
    }
    /**
     *  获取属性值[APPLICATIONID]
     */
    public String getApplicationid(){
        return this.applicationid;
    }
    /**
     *  重置属性值[APPLICATIONID]
     */
    public void resetApplicationid(){
        this.set("applicationiddirtyflag",false);
        this.applicationid = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[催办消息模板]
     *  @param remindmsgtemplid
     */
    public void setRemindmsgtemplid(String remindmsgtemplid){
        if(StringUtils.isEmpty(remindmsgtemplid))
            remindmsgtemplid=null;
        this.remindmsgtemplid = remindmsgtemplid;
        this.set("remindmsgtempliddirtyflag",true);
    }
     /**
     *    remindmsgtemplid :remindmsgtempid
     *   当属性名称与代码名称不一致时，
     *   多发一套get属性名称方法给gridvo用
     */
    public String getRemindmsgtempid(){
        return  remindmsgtemplid;
    }
     /**
     *    remindmsgtemplid :remindmsgtempid
     *   关闭mp驼峰转换，当属性名称与代码名称不一致时，多发一套set用于值注入
     */
    public void setRemindmsgtempid(String remindmsgtempid){
        this.remindmsgtemplid=remindmsgtempid;
    }
    /**
     *  获取属性值[催办消息模板]
     */
    public String getRemindmsgtemplid(){
        return this.remindmsgtemplid;
    }
    /**
     *  重置属性值[催办消息模板]
     */
    public void resetRemindmsgtemplid(){
        this.set("remindmsgtempliddirtyflag",false);
        this.remindmsgtemplid = null;
    }
    /**
     *  设置属性值[催办消息模板]
     *  @param remindmsgtemplname
     */
    public void setRemindmsgtemplname(String remindmsgtemplname){
        if(StringUtils.isEmpty(remindmsgtemplname))
            remindmsgtemplname=null;
        this.remindmsgtemplname = remindmsgtemplname;
        this.set("remindmsgtemplnamedirtyflag",true);
    }
    /**
     *  获取属性值[催办消息模板]
     */
    public String getRemindmsgtemplname(){
        //填充物理化的外键值附加数据
        if(StringUtils.isEmpty(this.remindmsgtemplname)&&(!StringUtils.isEmpty(this.getRemindmsgtemplid())) && this.getRemindmsgtempl()!=null)
        {
            this.remindmsgtemplname = this.getRemindmsgtempl().getMsgtemplatename();
            this.set("remindmsgtemplnamedirtyflag",true);
        }
        return this.remindmsgtemplname;
    }
    /**
     *  重置属性值[催办消息模板]
     */
    public void resetRemindmsgtemplname(){
        this.set("remindmsgtemplnamedirtyflag",false);
        this.remindmsgtemplname = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[工作流应用设定标识]
     *  @param wfappsettingid
     */
    public void setWfappsettingid(String wfappsettingid){
        if(StringUtils.isEmpty(wfappsettingid))
            wfappsettingid=null;
        this.wfappsettingid = wfappsettingid;
        this.set("wfappsettingiddirtyflag",true);
    }
    /**
     *  获取属性值[工作流应用设定标识]
     */
    public String getWfappsettingid(){
        return this.wfappsettingid;
    }
    /**
     *  重置属性值[工作流应用设定标识]
     */
    public void resetWfappsettingid(){
        this.set("wfappsettingiddirtyflag",false);
        this.wfappsettingid = null;
    }
    /**
     *  设置属性值[系统工作流设定]
     *  @param wfappsettingname
     */
    public void setWfappsettingname(String wfappsettingname){
        if(StringUtils.isEmpty(wfappsettingname))
            wfappsettingname=null;
        this.wfappsettingname = wfappsettingname;
        this.set("wfappsettingnamedirtyflag",true);
    }
    /**
     *  获取属性值[系统工作流设定]
     */
    public String getWfappsettingname(){
        return this.wfappsettingname;
    }
    /**
     *  重置属性值[系统工作流设定]
     */
    public void resetWfappsettingname(){
        this.set("wfappsettingnamedirtyflag",false);
        this.wfappsettingname = null;
    }
     /**
     *  获取主实体关联数据[MsgTemplate]
     */
    public MsgTemplate getRemindmsgtempl() {
        return remindmsgtempl;
    }
    /**
     *  设置主实体关联数据[MsgTemplate]
     */
    public void setRemindmsgtempl(MsgTemplate remindmsgtempl) {
        this.remindmsgtempl = remindmsgtempl;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetApplicationid();
        resetCreatedate();
        resetCreateman();
        resetMemo();
        resetRemindmsgtemplid();
        resetRemindmsgtemplname();
        resetUpdatedate();
        resetUpdateman();
        resetWfappsettingid();
        resetWfappsettingname();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public WFAppSetting copyTo(WFAppSetting targetEntity)
	{
		BeanCopier copier=BeanCopier.create(WFAppSetting.class, WFAppSetting.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetWfappsettingid();
		return targetEntity;
	}
}